Bug 106229 - Backtrace wrong after register push
Backtrace wrong after register push
Status: CLOSED CANTFIX
Product: Red Hat Linux
Classification: Retired
Component: gdb (Show other bugs)
9
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Elena Zannoni
David Lawrence
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2003-10-03 16:00 EDT by Rob West
Modified: 2007-04-18 12:58 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-01-02 14:10:49 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Source of test program (1.93 KB, text/plain)
2003-10-03 16:02 EDT, Rob West
no flags Details
Binary of test program (432.47 KB, text/plain)
2003-10-03 16:03 EDT, Rob West
no flags Details
Capture from gdb session (433 bytes, text/plain)
2003-10-03 16:03 EDT, Rob West
no flags Details

  None (edit)
Description Rob West 2003-10-03 16:00:52 EDT
Description of problem:

Just before some syscalls, one or more registers used to pass parameters to the
kernel are pushed onto the stack in order to restore their values after the call
returns. After you do 'stepi' over one of these pushes, 'backtrace' produces
incorrect output. How wrong seems to depend on undetermined circumstances. We've
seen frame #1 be corrupt. We seen ?? as frame #0 and missing frames.

Version-Release number of selected component (if applicable):
5.3post-0.20021129.18
5.3.90-0.20030710.21 (Rawhide)

How reproducible:
Always

Steps to Reproduce:
1. Run gdb for uploaded test program (source attached also)
2. Set breakpoint on read
3. Run until breakpoint
4. Do 'disass' to get the assembly for the function
5. Do 'stepi' until just before the push %ebx
6. Do 'bt'
7. Do 'stepi'
8. Do 'bt'. Notice difference compared to last backtrace.
    
Actual results:
Different backtrace between steps 6 and 8.

Expected results:
Same backtrace between steps 6 and 8.

Additional info:
Uploaded source, binary, and gdb capture.
Comment 1 Rob West 2003-10-03 16:02:43 EDT
Created attachment 94925 [details]
Source of test program
Comment 2 Rob West 2003-10-03 16:03:19 EDT
Created attachment 94926 [details]
Binary of test program
Comment 3 Rob West 2003-10-03 16:03:52 EDT
Created attachment 94927 [details]
Capture from gdb session
Comment 4 Bill Nottingham 2006-08-05 01:08:41 EDT
Red Hat apologizes that these issues have not been resolved yet. We do want to
make sure that no important bugs slip through the cracks.

Red Hat Linux 7.3 and Red Hat Linux 9 are no longer supported by Red Hat, Inc.
They are maintained by the Fedora Legacy project (http://www.fedoralegacy.org/)
for security updates only. If this is a security issue, please reassign to the
'Fedora Legacy' product in bugzilla. Please note that Legacy security update
support for these products will stop on December 31st, 2006.

If this is not a security issue, please check if this issue is still present
in a current Fedora Core release. If so, please change the product and version
to match, and check the box indicating that the requested information has been
provided.

If you are currently still running Red Hat Linux 7.3 or 9, please note that
Fedora Legacy security update support for these products will stop on December
31st, 2006. You are strongly advised to upgrade to a current Fedora Core release
or Red Hat Enterprise Linux or comparable. Some information on which option may
be right for you is available at http://www.redhat.com/rhel/migrate/redhatlinux/.

Any bug still open against Red Hat Linux 7.3 or 9 at the end of 2006 will be
closed 'CANTFIX'. Again, if this bug still exists in a current release, or is a
security issue, please change the product as necessary. We thank you for your
help, and apologize again that we haven't handled these issues to this point.
Comment 6 Bill Nottingham 2007-01-02 14:10:49 EST
Red Hat Linux 7.3 and Red Hat Linux 9 are no longer supported by Red Hat, Inc.
f you are currently still running Red Hat Linux 7.3 or 9, you are strongly
advised to upgrade to a current Fedora Core release or Red Hat Enterprise Linux
or comparable. Some information on which option may be right for you is
available at http://www.redhat.com/rhel/migrate/redhatlinux/.

Closing as CANTFIX.

Note You need to log in before you can comment on or make changes to this bug.